# Platform Class Reference

A Platform defines an implementation of all the kernels needed to perform some calculation. More...

Inherits simtk::openmm::openmm::_object.

List of all members.

## Public Member Functions
def | __init__
def | __del__
| __del__(OpenMM.Platform self)
def | registerPlatform
| registerPlatform(Platform platform)
def | getNumPlatforms
| getNumPlatforms() -> int
def | getPlatform
| getPlatform(int index) -> Platform
def | getPlatformByName
| getPlatformByName(std.string const & name) -> Platform
def | findPlatform
| findPlatform(vectorstring kernelNames) -> Platform
def | loadPluginLibrary
| loadPluginLibrary(std.string const & file)
def | loadPluginsFromDirectory
| loadPluginsFromDirectory(std.string const & directory) -> vectorstring
def | getDefaultPluginsDirectory
| getDefaultPluginsDirectory() -> std.string const &
def | getOpenMMVersion
| getOpenMMVersion() -> std.string const &
def | getName
| getName(Platform self) -> std.string const &
def | getSpeed
| getSpeed(Platform self) -> double
def | supportsDoublePrecision
| supportsDoublePrecision(Platform self) -> bool
def | getPropertyNames
| getPropertyNames(Platform self) -> vectorstring
def | getPropertyValue
| getPropertyValue(Platform self, Context context, std.string const & property) -> std.string const &
def | setPropertyValue
| setPropertyValue(Platform self, Context context, std.string const & property, std.string const & value)
def | getPropertyDefaultValue
| getPropertyDefaultValue(Platform self, std.string const & property) -> std.string const &
def | setPropertyDefaultValue
| setPropertyDefaultValue(Platform self, std.string const & property, std.string const & value)
def | supportsKernels
| supportsKernels(Platform self, vectorstring kernelNames) -> bool

## Detailed Description

A Platform defines an implementation of all the kernels needed to perform some calculation.

More precisely, a Platform object acts as a registry for a set of KernelFactory objects which together implement the kernels. The Platform class, in turn, provides a static registry of all available Platform objects.

To get a Platform object, call

    Platform& platform Platform.findPlatform(kernelNames);

passing in the names of all kernels that will be required for the calculation you plan to perform. It will return the fastest available Platform which provides implementations of all the specified kernels. You can then call createKernel() to construct particular kernels as needed.

## Member Function Documentation

def __del__ | ( |  | self | ) |

__del__(OpenMM.Platform self)

def __init__ | ( |  | self,
|  |  | args,
|  |  | kwargs |
| ) |  |  |

def findPlatform | ( |  | args | ) |

findPlatform(vectorstring kernelNames) -> Platform

Find a Platform which can be used to perform a calculation.

Parameters:

  | kernelNames | the names of all kernels which will be needed for the calculation

def getDefaultPluginsDirectory | ( |  | ) |

getDefaultPluginsDirectory() -> std.string const &

Get the default directory from which to load plugins. If the environment variable OPENMM_PLUGIN_DIR is set, this returns its value. Otherwise, it returns a platform specific default location.

def getName | ( |  | self | ) |

getName(Platform self) -> std.string const &

Get the name of this platform. This should be a unique identifier which can be used to recognized it.

def getNumPlatforms | ( |  | ) |

getNumPlatforms() -> int

Get the number of Platforms that have been registered.

def getOpenMMVersion | ( |  | ) |

getOpenMMVersion() -> std.string const &

Get a string containing the version number of the OpenMM library.

def getPlatform | ( |  | args | ) |

getPlatform(int index) -> Platform

Get a registered Platform by index.

def getPlatformByName | ( |  | args | ) |

getPlatformByName(std.string const & name) -> Platform

Get the registered Platform with a particular name. If no Platform with that name has been registered, this throws an exception.

def getPropertyDefaultValue | ( |  | self,
|  |  | args |
| ) |  |  |

getPropertyDefaultValue(Platform self, std.string const & property) -> std.string const &

Get the default value of a Platform-specific property. This is the value that will be used for newly created Contexts.

Parameters:

  | property | the name of the property to get

def getPropertyNames | ( |  | self | ) |

getPropertyNames(Platform self) -> vectorstring

Get the names of all Platform-specific properties this Platform supports.

def getPropertyValue | ( |  | self,
|  |  | args |
| ) |  |  |

getPropertyValue(Platform self, Context context, std.string const & property) -> std.string const &

Get the value of a Platform-specific property for a Context.

Parameters:

  | context | the Context for which to get the property
  | property | the name of the property to get

def getSpeed | ( |  | self | ) |

getSpeed(Platform self) -> double

Get an estimate of how fast this Platform class is. This need not be precise. It only is expected to return an order or magnitude estimate of the relative performance of different Platform classes. An unoptimized reference implementation should return 1.0, and all other Platforms should return a larger value that is an estimate of how many times faster they are than the reference implementation.

def loadPluginLibrary | ( |  | args | ) |

loadPluginLibrary(std.string const & file)

Load a dynamic library (DLL) which contains an OpenMM plugin. Typically, each Platform is distributed as a separate dynamic library. This method can then be called at runtime to load each available library. Each library should contain an initializer function to register any Platforms and KernelFactories that it contains.

If the file does not exist or cannot be loaded, an exception is thrown.

Parameters:

  | file | the path to the dynamic library file. This is interpreted using the operating system's rules for loading libraries. Typically it may be either an absolute path or relative to a set of standard locations.

def loadPluginsFromDirectory | ( |  | args | ) |

loadPluginsFromDirectory(std.string const & directory) -> vectorstring

Load multiple dynamic libraries (DLLs) which contain OpenMM plugins from a single directory. This method loops over every file contained in the specified directory and calls loadPluginLibrary() for each one. If an error occurs while trying to load a particular file, that file is simply ignored.

Parameters:

  | directory | the path to the directory containing libraries to load

def registerPlatform | ( |  | args | ) |

registerPlatform(Platform platform)

Register a new Platform.

def setPropertyDefaultValue | ( |  | self,
|  |  | args |
| ) |  |  |

setPropertyDefaultValue(Platform self, std.string const & property, std.string const & value)

Set the default value of a Platform-specific property. This is the value that will be used for newly created Contexts.

Parameters:

  | property | the name of the property to set
  | value | the value to set for the property

def setPropertyValue | ( |  | self,
|  |  | args |
| ) |  |  |

setPropertyValue(Platform self, Context context, std.string const & property, std.string const & value)

Set the value of a Platform-specific property for a Context.

Parameters:

  | context | the Context for which to set the property
  | property | the name of the property to set
  | value | the value to set for the property

def supportsDoublePrecision | ( |  | self | ) |

supportsDoublePrecision(Platform self) -> bool

Get whether this Platform supports double precision arithmetic. If this returns false, the platform is permitted to represent double precision values internally as single precision.

def supportsKernels | ( |  | self,
|  |  | args |
| ) |  |  |

supportsKernels(Platform self, vectorstring kernelNames) -> bool

Determine whether this Platforms provides implementations of a set of kernels.

Parameters:

  | kernelNames | the names of the kernels of interests

The documentation for this class was generated from the following file:

- openmm.py